#include "libgraph.h"
#include <alloc.h>

value gr_plot(vx, vy) 
     value vx, vy;
{
  int x = Int_val(vx);
  int y = Int_val(vy); 

#ifdef DEBUG_DRAW
   fprintf(stderr,"gr_plot: Validwin=%d; x,y=%d,%d\n", ValidWindow, x, y);
#endif 

  if(ValidWindow==FALSE) return Val_unit;
  XDrawPoint(grdisplay, grwindows[current_window].win,
             grwindows[current_window].gc, x, Wcvt(y));
/*  XFlush(grdisplay); */
  return Val_unit;
}

value gr_moveto(vx, vy)
     value vx, vy;
{
  int x = Int_val(vx);
  int y = Int_val(vy); 

#ifdef DEBUG_DRAW
   fprintf(stderr,"gr_moveto: Validwin=%d; x,y=%d,%d\n", ValidWindow, x, y);
#endif 
  if(ValidWindow==FALSE) return Val_unit;
  grwindows[current_window].grx = x;
  grwindows[current_window].gry = y;
  return Val_unit;
}

value gr_current_point()
{
  value res;
  int x,y;

  if(ValidWindow==FALSE) x=y=0; 
  else
  {
    x=grwindows[current_window].grx;
    y=grwindows[current_window].gry;
  }

#ifdef DEBUG_DRAW 
   fprintf(stderr,"gr_current_point: return x,y=%d,%d\n", x, y);
#endif 

  res = alloc_tuple(2);
  Field(res, 0) = Val_int(grwindows[current_window].grx);
  Field(res, 1) = Val_int(grwindows[current_window].gry);
  return res;
}

value gr_lineto(vx, vy)
     value vx, vy;
{
  int x = Int_val(vx);
  int y = Int_val(vy);

#ifdef DEBUG_DRAW 
   fprintf(stderr,"gr_lineto: Validwin=%d; x,y=%d,%d\n", ValidWindow, x, y);
#endif 

  if(ValidWindow==FALSE) return Val_unit;
  XDrawLine(grdisplay, grwindows[current_window].win, 
	    grwindows[current_window].gc,
            grwindows[current_window].grx, Wcvt(grwindows[current_window].gry),
	    x, Wcvt(y));
  grwindows[current_window].grx = x;
  grwindows[current_window].gry = y;
/*  XFlush(grdisplay); */

  return Val_unit;
}

value gr_draw_arc(argv, argc)
     int argc;
     value * argv;
{
  int x = Int_val(argv[0]);
  int y = Int_val(argv[1]);
  int rx = Int_val(argv[2]);
  int ry = Int_val(argv[3]);
  int a1 = Int_val(argv[4]);
  int a2 = Int_val(argv[5]);

#ifdef DEBUG_DRAW 
   fprintf(stderr,"gr_draw_arc: Validwin=%d; x,y=%d,%d\n", ValidWindow, x, y);
#endif 

  if(ValidWindow==FALSE) return Val_unit;
  XDrawArc(grdisplay, grwindows[current_window].win, 
	   grwindows[current_window].gc,
           x - rx, Wcvt(y) - ry, rx * 2, ry * 2, a1 * 64, (a2 - a1) * 64);
#ifdef DEBUG_DRAW 
   fprintf(stderr,"gr_draw_arc: end\n");
#endif 

  return Val_unit;
}


